#ifndef EXTERNAL_KEM_kyber_kyber512_amd64_avx2_API_H
#define EXTERNAL_KEM_kyber_kyber512_amd64_avx2_API_H

#include <stdint.h>

#define EXTERNAL_KEM_kyber_kyber512_amd64_avx2_SECRETKEYBYTES   1632
#define EXTERNAL_KEM_kyber_kyber512_amd64_avx2_PUBLICKEYBYTES   800
#define EXTERNAL_KEM_kyber_kyber512_amd64_avx2_CIPHERTEXTBYTES  768
#define EXTERNAL_KEM_kyber_kyber512_amd64_avx2_KEYPAIRCOINBYTES 64
#define EXTERNAL_KEM_kyber_kyber512_amd64_avx2_ENCCOINBYTES     32
#define EXTERNAL_KEM_kyber_kyber512_amd64_avx2_BYTES            32

#define EXTERNAL_KEM_kyber_kyber512_amd64_avx2_ALGNAME         "Kyber512"
#define EXTERNAL_KEM_kyber_kyber512_amd64_avx2_ARCH            "amd64"
#define EXTERNAL_KEM_kyber_kyber512_amd64_avx2_IMPL            "avx2"

int external_kem_kyber_kyber512_amd64_avx2_keypair_derand(
  uint8_t *public_key,
  uint8_t *secret_key,
  const uint8_t *coins
);

int external_kem_kyber_kyber512_amd64_avx2_keypair(
  uint8_t *public_key,
  uint8_t *secret_key
);

int external_kem_kyber_kyber512_amd64_avx2_enc_derand(
  uint8_t *ciphertext,
  uint8_t *shared_secret,
  const uint8_t *public_key,
  const uint8_t *coins
);

int external_kem_kyber_kyber512_amd64_avx2_enc(
  uint8_t *ciphertext,
  uint8_t *shared_secret,
  const uint8_t *public_key
);

int external_kem_kyber_kyber512_amd64_avx2_dec(
  uint8_t *shared_secret,
  const uint8_t *ciphertext,
  const uint8_t *secret_key
);

#endif
