#include "api.h"

extern int PQCP_MLKEM_NATIVE_MLKEM512_keypair_derand(uint8_t *,uint8_t *, const uint8_t *);
extern int PQCP_MLKEM_NATIVE_MLKEM512_keypair(uint8_t *,uint8_t *);
extern int PQCP_MLKEM_NATIVE_MLKEM512_enc_derand(uint8_t *,uint8_t *, const uint8_t *, const uint8_t *);
extern int PQCP_MLKEM_NATIVE_MLKEM512_enc(uint8_t *, uint8_t *, const uint8_t *);
extern int PQCP_MLKEM_NATIVE_MLKEM512_dec(uint8_t *, const uint8_t *, const uint8_t *);

int external_kem_kyber_kyber512_amd64_avx2_keypair_derand(
  uint8_t *public_key,
  uint8_t *secret_key,
  const uint8_t *coins
)
{
  return PQCP_MLKEM_NATIVE_MLKEM512_keypair_derand(public_key, secret_key, coins);
}

int external_kem_kyber_kyber512_amd64_avx2_keypair(
  uint8_t *public_key,
  uint8_t *secret_key
)
{
  return PQCP_MLKEM_NATIVE_MLKEM512_keypair(public_key, secret_key);
}

int external_kem_kyber_kyber512_amd64_avx2_enc_derand(
  uint8_t *ciphertext,
  uint8_t *shared_secret,
  const uint8_t *public_key,
  const uint8_t *coins
)
{
  return PQCP_MLKEM_NATIVE_MLKEM512_enc_derand(ciphertext, shared_secret, public_key, coins);
}

int external_kem_kyber_kyber512_amd64_avx2_enc(
  uint8_t *ciphertext,
  uint8_t *shared_secret,
  const uint8_t *public_key
)
{
  return PQCP_MLKEM_NATIVE_MLKEM512_enc(ciphertext, shared_secret, public_key);
}

int external_kem_kyber_kyber512_amd64_avx2_dec(
  uint8_t *shared_secret,
  const uint8_t *ciphertext,
  const uint8_t *secret_key
)
{
  return PQCP_MLKEM_NATIVE_MLKEM512_dec(shared_secret, ciphertext, secret_key);
}

