#ifndef EXTERNAL_SECRETBOX_xsalsa20poly1305_amd64_avx2_API_H
#define EXTERNAL_SECRETBOX_xsalsa20poly1305_amd64_avx2_API_H
#define EXTERNAL_SECRETBOX_xsalsa20poly1305_amd64_avx2_KEYBYTES 32
#define EXTERNAL_SECRETBOX_xsalsa20poly1305_amd64_avx2_NONCEBYTES 24
#define EXTERNAL_SECRETBOX_xsalsa20poly1305_amd64_avx2_ZEROBYTES 32
#define EXTERNAL_SECRETBOX_xsalsa20poly1305_amd64_avx2_BOXZEROBYTES 16
#define EXTERNAL_SECRETBOX_xsalsa20poly1305_amd64_avx2_ALGNAME "XSalsa20/20Poly1305"
#define EXTERNAL_SECRETBOX_xsalsa20poly1305_amd64_avx2_ARCH "amd64"
#define EXTERNAL_SECRETBOX_xsalsa20poly1305_amd64_avx2_IMPL "avx2"

#include <stdint.h>

int external_secretbox_xsalsa20poly1305_amd64_avx2(
  uint8_t *ciphertext,
  const uint8_t *plaintext,
  uint64_t plaintext_length,
  const uint8_t *nonce,
  const uint8_t *key
);

int external_secretbox_xsalsa20poly1305_amd64_avx2_open(
  uint8_t *plaintext,
  const uint8_t *ciphertext,
  uint64_t ciphertext_length,
  const uint8_t *nonce,
  const uint8_t *key
);

#endif
