#include "api.h"

extern void randombytes(uint8_t *, uint64_t);

uint8_t* __jasmin_syscall_randombytes__(uint8_t* _x, uint64_t xlen)
{
  randombytes(_x, xlen);
  return _x;
}

extern int crypto_secretbox_xsalsa20poly1305(uint8_t *, const uint8_t *, uint64_t, const uint8_t *, const uint8_t *);
extern int crypto_secretbox_xsalsa20poly1305_open(uint8_t *, const uint8_t *, uint64_t, const uint8_t *, const uint8_t *);

int external_secretbox_xsalsa20poly1305_amd64_avx2(
  uint8_t *ciphertext,
  const uint8_t *plaintext,
  uint64_t plaintext_length,
  const uint8_t *nonce,
  const uint8_t *key
)
{
  return crypto_secretbox_xsalsa20poly1305(ciphertext, plaintext, plaintext_length, nonce, key);
}

int external_secretbox_xsalsa20poly1305_amd64_avx2_open(
  uint8_t *plaintext,
  const uint8_t *ciphertext,
  uint64_t ciphertext_length,
  const uint8_t *nonce,
  const uint8_t *key
)
{
  return crypto_secretbox_xsalsa20poly1305_open(plaintext, ciphertext, ciphertext_length, nonce, key);
}
