#include "api.h"
#include <string.h>

extern void ChaCha20_ctr32(uint8_t *, uint8_t *, uint64_t, const uint8_t *, const uint8_t *);

int external_stream_chacha_chacha20_ietf_amd64_avx2(
  uint8_t *stream,
  uint64_t stream_length,
  const uint8_t *n,
  const uint8_t *k
)
{
  uint8_t counter_nonce[16];
  memset(stream, 0, stream_length); // not to be benchmarked
  memset(counter_nonce, 0, 4);
  memcpy(counter_nonce+4, n, 8);
  ChaCha20_ctr32(stream, stream, stream_length, k, counter_nonce);
	return 0;
}

int external_stream_chacha_chacha20_ietf_amd64_avx2_xor(
  uint8_t *out,
  uint8_t *in,
  uint64_t inlen,
  const uint8_t *n,
  const uint8_t *k
)
{
  uint8_t counter_nonce[16];
  memset(counter_nonce, 0, 4);
  memcpy(counter_nonce+4, n, 8);
  ChaCha20_ctr32(out, in, inlen, k, counter_nonce);
  return 0;
}
